package br.usp.ime.blog.jsf.admin;

import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.servlet.http.HttpServletRequest;

import br.usp.ime.blog.dominio.Blogueiro;
import br.usp.ime.blog.repositorios.FabricaDeRepositorios;
import br.usp.ime.blog.repositorios.RepositorioDeBlogueiros;
import br.usp.ime.blog.repositorios.RepositorioException;

public class AutenticadorBean {

	private String login;
	private String senha;
	private String mensagemDeErro;

	public String getLogin() {
		return login;
	}

	public void setLogin(String login) {
		this.login = login;
	}

	public String getSenha() {
		return senha;
	}

	public void setSenha(String senha) {
		this.senha = senha;
	}

	public String getMensagemDeErro() {
		return mensagemDeErro;
	}

	public void setMensagemDeErro(String mensagemDeErro) {
		this.mensagemDeErro = mensagemDeErro;
	}

	public String autentica() throws RepositorioException {
		RepositorioDeBlogueiros repositorioDeBlogueiros = FabricaDeRepositorios
				.fabricaRepositorioDeBlogueiros();

		Blogueiro blogueiro = repositorioDeBlogueiros.pegaBlogueiro(login,
				senha);

		if (blogueiro != null) {
			guardaBlogueiroNaSessao(blogueiro);
			return "autenticado";
		}

		setMensagemDeErro("Login e/ou senha incorretos!");
		return null;
	}

	private void guardaBlogueiroNaSessao(Blogueiro blogueiro) {
		ExternalContext context = FacesContext.getCurrentInstance()
				.getExternalContext();
		HttpServletRequest request = (HttpServletRequest) context.getRequest();
		request.getSession().setAttribute("blogueiro", blogueiro);
	}
}
